<?

##############################################################################################
function authorized_exts($ext)
{
	global $FILE_MANAGER_EXTENSION;
	$ext = strtolower($ext) ;
	
	for($i = 0; $i < count($FILE_MANAGER_EXTENSION); $i++)
	{
		for($j = 0; $j < count($FILE_MANAGER_EXTENSION[$i]['EXT']); $j++)
		{
			if($ext == strtolower($FILE_MANAGER_EXTENSION[$i]['EXT'][$j])) return true;
		}
	}
	return false;
}
###############################################################################################
function extension($file)
{
	$tmp = explode (".", $file);
	if (count($tmp) > 1) return $tmp[count($tmp)-1];
	else return "Unknown";
}
###############################################################################################
function normalize_file($folder)
{	
	while (ereg('//', $folder)) $folder = str_replace ("//", "/", $folder) ;
	/*if (ereg('\.\./', $folder)) return false;
	if (ereg('\./', $folder)) return false;
	if (ereg('/\.\.', $folder)) return false;
	if (ereg('\$', $folder)) return false;
	if (ereg('~', $folder)) return false;*/
	if (ereg('^\.\.\/|\/\.\.\/|\/\.\.$|^\.\.$', $folder)) return false;
	if (ereg('\$', $folder)) return false;
	if (ereg('~', $folder)) return false;
	return $folder;
}


function normalize($folder)
{
	$folder .= "/";	
	return normalize_file($folder);
}
###############################################################################################
//
// suppression avancee d'un repertoire
//
// DESCRIPTION
// > permet de supprimer un dossier meme s'il n'est pas vide. Le script explore tout le contenu et le supprime
// > avant de supprimer le dossier.
//
// >> Parametres d'entree :
// > $dir : STRING / chemin d'acces au dossier a supprimer
//
// >> Parametre de sortie : BOOLEEN / TRUE si dossier supprime, FALSE en cas d'erreur
function advRmDir( $dir )
{  
 // ajout du slash a la fin du chemin s'il n'y est pas
 if( !preg_match( "/^.*\/$/", $dir ) ) $dir .= '/';
  
 // Ouverture du repertoire demande
 $handle = @opendir( $dir );
  
 // si pas d'erreur d'ouverture du dossier on lance le scan
 if( $handle != false )
 {
   
  // Parcours du repertoire
  while( $item = readdir($handle) )
  {
   if($item != "." && $item != "..")
   {
    if( is_dir( $dir.$item ) )
     advRmDir( $dir.$item );
    else @unlink( $dir.$item );
   }
  }
   
  // Fermeture du repertoire
  @closedir($handle);
   
  // suppression du repertoire
  $res = @rmdir( $dir );
   
 }
 else $res = false;
  
 return $res;
  
}
###############################################################################

class gest_fax
{
	// Numro du destinataire
	var $numero_dest = "";
	// Lien fichier
	var $filename = "" ;
	// $extension du fichier
	var $extension =  "" ;
	//$emplacement fichier
	var $emplacement = "" ;
	
	function extract_extension()
	{
		if (($this->filename) != "")
		{
			$extension = "" ;
			$pos = strrpos($this->filename,'.');
			$extension = substr($this->filename,$pos+1) ;
			$extension = strtolower ( $extension ) ;	
			return $extension;	
		} else return "" ;	
	}
	
	function envoie_fax()
	{
		// Retourne 0 si l'extension n'est pas prise en charge
		// Retourne la sortie du fax si l'extension est gre
		global $_RACINE;
		$_racine_globale = $_RACINE . "/archives/";
		$output = "" ;
		$this->extension = $this->extract_extension() ;
		$src = $_racine_globale . "/stockage/" . $this->emplacement . "/" . $this->filename ;	
		
		$filename_no_ext = date("Ymd-his") ;
		$dest = $_racine_globale . "/tmp/$filename_no_ext" ;	
		switch ($this->extension)
		{
			case "gif" : 
				$output = $dest . ".tif" ;
				copy ($src, $dest . ".gif") ;
				system ("giftopnm " . $dest . ".gif" . " | pnmtotiff > $output") ;
				if (file_exists($dest . ".gif")) @unlink ($dest . ".gif") ;
				break ;
				
			case "pdf" : 
				$output = $dest . ".pdf" ;
				copy ($src, $dest . ".pdf") ;
				//system ("pdf2ps " . $dest . ".pdf" . " $output") ;
				//if (file_exists($dest . ".pdf")) @unlink ($dest . ".pdf") ;
				break ;
				
			case "jpg" : 
				$output =  $dest . ".tif" ;
				copy ($src, $dest . ".jpg") ;
				system("jpegtopnm " . $dest . ".jpg" . " | pnmtotiff > $output") ;	
				if (file_exists($dest . ".jpg")) @unlink ($dest . ".jpg") ;
				break ;
				
			case "rtf" : 
				$output = $dest . ".ps" ;				
				system("unrtf --ps $src > $output") ;
				break;	
				
			case "doc" : 			
				$output = $dest . ".ps" ;
				copy ($src, $dest . ".doc") ;
				system("antiword " . $dest . ".doc" . " -p a4 > $output") ;
				if (file_exists($dest . ".doc")) @unlink ($dest . ".doc") ;
				break ;
				
			case "ps" : 
				$output = $dest . ".ps" ;
				copy ($src, $dest . ".ps") ;
				$output = $dest . ".ps" ;
				break;
				
			case "tif" :

				$output = $dest . ".tif" ;
				copy ($src, $dest . ".tif") ;
				break ;

			case "txt" :

				$output = $dest . ".txt" ;
				copy ($src, $dest . ".txt") ;
				break ;
				
			case "default" :
				return 1; 
				break ;
	
		}
		$result = exec ("sendfax -n -d " . escapeshellarg($this->numero_dest) . " " . escapeshellarg($output)) ;
		if (file_exists($output)) @unlink($output) ;
		
		return $result ;
	
	}
}

function get_icon($ext="")
{
	if ($ext)
	{
		if (is_file("icones/filetypes/" . $ext . ".gif")) return  $ext . ".gif";
		else return "file.gif" ;
	}
	else return "folder_closed.gif";
}

function date_fichier($date) {
   return date("d/m/Y H:i:s",$date);
}

function print_action_dossier($dossier, $sous_dossier)
{
	$menu = "<a href=\"javascript:rename_folder('" . urlencode($dossier) . "','" . $sous_dossier . "')\"><img title='Renommer' border=0 src='icones/actions/edit.gif'></a>";
	$menu .= "<a href=\"javascript:delete_folder('" . urlencode($dossier."/" . $sous_dossier) . "')\"><img title='Supprimer' border=0 src='icones/actions/trash.gif'></a>";
	$menu .= "<a href=\"javascript:move_folder ('" . urlencode($dossier."/".$sous_dossier) . "')\"><img title='D�placer' border=0 src='icones/actions/move.gif'></a>";
	return $menu;
} 

function print_action_fichier($dossier, $file_name)
{
	//$menu = "<a href=\"javascript:popup(820, 250, 'rename_file.php?file=" . urlencode($file) . "','no', 'yes', 'no')\"><img title='Renommer' border=0 src='icones/actions/edit.gif'></a>";
	$menu = "<a href=\"javascript:rename('" . urlencode($dossier) . "','" . $file_name . "')\"><img title='Renommer' border=0 src='icones/actions/edit.gif'></a>";
	$menu .= "<a href=\"javascript:delete_file('" . urlencode($dossier."/".$file_name) . "')\"><img title='Supprimer' border=0 src='icones/actions/trash.gif'></a>";
	$menu .= "<a href=\"javascript:move('" . urlencode($dossier."/".$file_name) . "')\"><img title='D�placer' border=0 src='icones/actions/move.gif'></a>";
	$menu .= "<a href=\"javascript:email_file('" . urlencode($dossier."/".$file_name) . "')\"><img title='Email' border=0 src='icones/actions/email.gif'></a>";
	$menu .= "<a href=\"javascript:envoi_fax('" . urlencode($dossier."/".$file_name) . "')\"><img title='Fax' border=0 src='icones/actions/fax.gif'></a>";
	return $menu;
}

function liste_dossiers ($directory)
{
	$str = explode("/" , $directory);
	$string = "<a href='index.php?dossier=" . urlencode("/") . "'>Home</a> / " ;
	foreach ($str as $value)
	{			
		if ($value) 
		{
			$dossier_actuel .= ("/" . $value);
			$string .= "<a href='index.php?dossier=" . urlencode($dossier_actuel) . "'>" . htmlentities($value) . "</a> / " ;
		}
	}
	return $string ;
}

function filesize_format($bytes)
{
   if ( 0 >= $bytes)
   {
   return $bytes;
   }
   $names = array( 'B', 'KB', 'MB', 'GB', 'TB');
   $values = array( 1, 1024, 1048576, 1073741824, 1099511627776);
   $i = floor(log($bytes)/6.9314718055994530941723212145818);    //log(1024) = 6.9314718055994530941723212145818
   return number_format($bytes/$values[$i]).' '.$names[$i];
}

function has_folder_access($folder, $login=NULL) {
	if(!$login) {
		global $application;
		$login = $application->userprefs['login'];
	}
	
	exec("getfacl " . escapeshellarg($folder), $user_access_list);
	if(is_array($user_access_list)) {
		$cpt = 0;
		foreach($user_access_list as $user) {
			$cpt++;
			if($cpt < 4) continue;
			if(preg_match("/^user\:([\w]+)\:/", $user, $return)) {
				if($login == $return[1]) return true;
			}	
		}
	}
	
	return false;
	

}

?>