<?
session_start();

include "../../config.php";
include "../../includes/common_librairie.php";
include "../../includes/xajax/xajax.inc.php";
require_once("../../index_common.php");
include "lib_files_manager.php";

// Initialization of the application
$application = new application();

if(!$application->is_loged)
{// Loged or not loged, that's the question.
	die("You are not loged");
}

########################  !! Access to this page !! ###############################
if($application->userprefs['user_type'] == "employee")
{
	$file_manager_access = $application->module_access("file_manager");
	if($file_manager_access != "TECH" && $file_manager_access != "ADMIN")
	{// For the employee, just access for the admins and techs users
		$application->message_die("You have not access to this page");
	}
	$application->add_var("IS_EMPLOYEE", true);
}


//  Detection de la rubrique dans laquelle on se trouve pour savoir quel dossier chrooter
if(!isset($_GET['rubrique']) && !isset($_POST['rubrique'])) die("Unknown section");
isset($_GET['rubrique']) ? $rubrique = $_GET['rubrique'] : $rubrique = $_POST['rubrique'];


switch($rubrique)
{
	case 0 :
		($application->userprefs['user_type'] == "employee") ?
			$BASE_FOLDER = FILE_NANAGER_FILES_CLIENTS_FOLDER :
			$BASE_FOLDER = FILE_NANAGER_FILES_CLIENTS_FOLDER . "/" . str_replace("/", "-", $application->userprefs['user_label']) . " (" . $application->userprefs['id_user'] . ")";
		break;
	case 1 :
		$BASE_FOLDER = create_smb_url() . "/PARTAGES/";
		break;
	case 2 :
		$BASE_FOLDER = create_smb_url() . "/PERSO/";
		break;
}


if(!is_dir($BASE_FOLDER)) $application->message_die("Unknown root directory");
if(!is_dir($BASE_FOLDER . $dossier)) $application->message_die("Unknown directory");
if(!is_writable($BASE_FOLDER)) $application->message_die("This folder is not writable");
if(!is_readable($BASE_FOLDER)) $application->message_die("This folder is not readable");
	
###### Affichage des dossiers et des fichiers #######################################


$liste_fichier = NULL;
$liste_folder = NULL;

function list_files($dossier, $recherche)
{
	global $liste_fichier;
	global $liste_folder;
	global $BASE_FOLDER;
	
	$tmp_folders = NULL ;
	$i_fold = 0;
	// Si le dossier n'existe pas, on ne le liste pas
	if (!is_dir($dossier)) return 0;
	
	$id = opendir($dossier);
	while (false !== ($file = readdir($id))) 
	{
		if(substr($file, 0, 1) != ".")
		{
			if (is_dir($dossier."/".$file)) 
			{// Traitement des dossiers
				if ($file != "." && $file != "..")
				{
					if ($pertinence = recherche($recherche, $dossier."/".$file))
					{
						$i = count($liste_folder);
						$liste_folder[$i]["affichage"] = $file;
						$liste_folder[$i]["lien"] = normalize(substr($dossier . "/" . $file, strlen($BASE_FOLDER)));			
						$liste_folder[$i]["pertinence"] = $pertinence;
					}
					list_files($dossier."/".$file, $recherche); 
				}
			}
			else
			{// Traitement des fichiers
				if ($pertinence = recherche($recherche, $dossier."/".$file))
				{
					$liste_fichier[] = array (
								"affichage" 	=> normalize_file($file),
								"lien"			=> normalize_file(substr($dossier . "/" . $file, strlen($BASE_FOLDER))),
								"pertinence"	=> $pertinence);
				}
			}
		}
	}	
}


##################################################

function recherche($pattern, $string)
{
	//echo "passe";
	$tmp_recherche = explode(" ", $pattern);
	$pertinence = 0;
	$string = normalize_file($string) ;
	$tb_string  = explode ("/", $string) ;
	$buffer = NULL;
	$in_name = false;
	$in_texte = false;
	$nb = 0;
	
	if (extension($string) == "rtf" || extension($string)  == "doc")
	{ // Utilisation de antiword
		exec("antiword " . escapeshellarg($string), $buffer) ;
		$buffer = strtolower(implode("\n", $buffer)) ;		
	}
	
	foreach($tmp_recherche as $value)
	{
		if ($value != "")
		{
			// SI le nom du fichier exact est trouv, alors on lui mets un bonus de recherche pour le faire monter dans le classement de pertinence
			if (strtolower($pattern) == strtolower($tb_string[count($tb_string)-1])) {$pertinence += 10; $in_name = true;}
			if (ereg(strtolower($value), strtolower($tb_string[count($tb_string)-1]))) {$pertinence++; $in_name = true;}
			
			// Recherche dans le contenu des fichiers, pour les fichiers possibles :
			if ($buffer) $nb =  substr_count($buffer, $value);
			if($nb) $in_texte = true;
			$pertinence += $nb;
		}
	}
	// Si les mots cl se trouvent dans le texte et dans le contenu, un bonus +10  la pertinence
	if ($in_name && $in_texte) $pertinence += 10;
	return $pertinence;
}


##################################################

list_files($BASE_FOLDER, $_GET['search_for']);
$application->add_var("search_for", htmlentities($_GET['search_for']));

if ($liste_fichier)
{
	// Obtient une liste de colonnes
	foreach ($liste_fichier as $key => $row) 
	{
	   $affichage[$key]  = $row['affichage'];
	   $pertinence[$key] = $row['pertinence'];
	}
	array_multisort($pertinence, SORT_DESC, $affichage,  SORT_ASC, SORT_STRING,  $liste_fichier);
}

for ($i = 0; $i < count($liste_folder); $i++)
{
	($cpt++%2 == 0) ? $class = "ligne1" : $class = "ligne2" ;
	$dossier =  str_replace ($liste_folder[$i]['affichage'], "", $liste_folder[$i]['lien']) ;

	$vars = array(
					"CLASS" => $class,
					"show_folder_name" => htmlentities($liste_folder[$i]['affichage'], NULL, "UTF-8"),
					"folder_to_open" => urlencode($liste_folder[$i]['lien']),
					"size" => "&nbsp;",
					"type" => "Folder",
					"icon" => get_icon(),
					"date" => date_fichier(filectime($BASE_FOLDER . "/" . $liste_folder[$i]['lien'])),
					"folder_name" => $dossier. "/",
					"file_name" => str_replace("/", "",$liste_folder[$i]['affichage']),
					"file_url" => $dossier. "/" . str_replace("/", "",$liste_folder[$i]['affichage']));

	$application->add_block("FILES_LIST", $vars);
}

for ($i = 0; $i < count($liste_fichier); $i++)
{
	($cpt++%2 == 0) ? $class = "ligne1" : $class = "ligne2" ;
	$dossier =  str_replace ($liste_fichier[$i]['affichage'], "", $liste_fichier[$i]['lien']) ;

	$vars = array(
					"CLASS" => $class,
					"is_file" => true,
					"show_file_name" => htmlentities($liste_fichier[$i]['affichage'], NULL, "UTF-8"),
					"file_to_download" => urlencode($dossier . "/" . $liste_fichier[$i]['affichage']),
					"size" => filesize_format(filesize($BASE_FOLDER . "/" . $liste_fichier[$i]['lien'])),
					"type" => strtoupper(extension($liste_fichier[$i]['affichage'])),
					"icon" => get_icon(strtolower(extension($liste_fichier[$i]['affichage']))),
					"date" => date_fichier(filectime($BASE_FOLDER . "/" . $liste_fichier[$i]['lien'])),
					"folder_name" => $dossier . "/",
					"file_name" => str_replace("/", "",$liste_fichier[$i]['affichage']),
					"file_url" => $dossier. "/" . str_replace("/", "",$liste_fichier[$i]['affichage']));

	$application->add_block("FILES_LIST", $vars);
}

$liste_dossiers = "" ;


################### Création de la navigation entre les dossiers #################
if($dossier && $dossier != "/")
{
	$application->add_block("exploration", array("folder" => "/", "folder_name" => "Home"));
	
	$folder_list = explode("/", $dossier);
	$complete_folder = "";
	
	if(is_array($folder_list))
	{
		foreach($folder_list as $folder)
		{
			if($folder) 
			{
				$complete_folder .= "/" . $folder;
				$application->add_block("exploration", array("folder" => $complete_folder, "folder_name" => $folder));
			}
		}
	}
}

##################################################################################
// Create content :
$CONTENT = $application->get_html_content("gestion_file_manager_search.htm");
if(!$CONTENT) $application->message_die("Unable to find the html page");
$application->set_page_title("{LANG_FILE_MANAGER_Folder_title}");

$application->add_var("current_folder", "/" . $dossier);
$application->add_var("rubrique", (int)$_GET['rubrique']);


################## Create the content of the page #################################
		
$replace = array("MENU" => $application->generate_menu());
$application->add_vars($replace);
$application->show_content($CONTENT);

?>